#include <stdio.h>
#include <stdlib.h>
#include <kqml.h>

int C_kqml_initialize (char *agent_name)
{
/*    ans_handler      ans_lookup_func = KQML_NOT_AN_ANS;*/
    int              result;

    result = kqml_initialize(agent_name, KQML_NOT_AN_ANS);
    _kqml_dbg_msg (KQML_DBG_VERBOSE) ("Is agent name OK?\n");
    return result;
}


int C_kqml_register (char *perf, int blocking)
{
	void	*generic_handler (void *, kqml_message *, KQML_REPLY_TYPE *);

	_kqml_dbg_msg (KQML_DBG_VERBOSE) ("Registering...\n");
	return kqml_register(generic_handler, perf, blocking);
}


void C_kqml_dbg_msg(char *comment)
{
    _kqml_dbg_msg (KQML_DBG_VERBOSE) ("%s.", comment);
}


kqml_message *C_kqml_send (int timeout, kqml_message *kmsg)
{
    kqml_message      *reply_msg;

    fprintf (stderr, "In the C_kqml_send...\n");
    kqml_print_msg (stderr, kmsg);
    
    if ( kqml_send(timeout, kmsg, &reply_msg) <= -1 )
    {
	fprintf (stderr, "kqml_send : Failed.\n");
	return NULL;
    }
    return (reply_msg);
}
	

void *C_null_pointer (void)
{
    return NULL;
}


kqml_message *C_kqml_parse (char *Str, int length)
{
    int                 ret_value, used_len;
    kqml_message        *kmsg;

    fprintf (stderr, "Calling kqml_parse_buffer.\n");
    ret_value = kqml_parse_buffer (Str, length, &used_len, &kmsg);
    fprintf (stderr, "kqml_parse_buffer returned : %d\n", ret_value);
    if (ret_value != KQML_PARSE_OK)
    {
	fprintf (stderr, "kqml-parse-buffer : Returned Error.\n");
	return NULL;
    }
    else
	return kmsg;
}


KQML_KMSG_LIST *C_kqml_build_kmsg_list (KQML_KMSG_LIST *kmsg_list,
				   kqml_message *kmsg)
{
    KQML_KMSG_LIST      *reply;
    
    if (kmsg_list == NULL)
	reply = kqml_build_kmsg_list (NULL, kmsg);
    else
	reply = kqml_build_kmsg_list (&kmsg_list, kmsg);
    return reply;
}


char *kqml_msg_to_str (kqml_message *kmsg)
{
    char               *str;
    int                len;
    
    str = kqml_sprint_msg(NULL, &len, kmsg);
    return str;
}


void *generic_handler(void *content, kqml_message *kmsg,
		      KQML_REPLY_TYPE *reply_type)
{
    
    /**** Prototype Declarations ****/
    char     *lisp_handler(char *, kqml_message *, KQML_REPLY_TYPE *);
    void     kqml_print_list (KQML_KMSG_LIST *);
    
    /**** Variables ****/
    char		*content_ptr = content;
    KQML_KMSG_LIST	*reply = NULL;
    
    reply = (KQML_KMSG_LIST *) lisp_handler (content_ptr, kmsg, reply_type);
    fprintf (stderr, "Returned to the generic handler , the message\n");
    kqml_print_list (reply);
    *reply_type = KQML_REPLY_KMSG_LIST;
    return (reply);
}


void kqml_print_list (KQML_KMSG_LIST *klist)
{
    KQML_KMSG_LIST   *temp;

    temp = klist;
    while (temp->next != klist)
    {
	fprintf (stderr, "The kqml message :\n");
	kqml_print_msg (stderr, temp->kmsg);
	temp = temp->next;
    }
    kqml_print_msg (stderr, temp->kmsg);
}
