#ifndef lint
static char *rcsid = "$Header: /iss/planning/idi/lim-clos-version/CVSROOT/c-kqml/qp_kqml.c,v 1.2 1995/06/23 20:36:57 robin Exp $";
#endif


/*
 * $Log: qp_kqml.c,v $
 * Revision 1.2  1995/06/23  20:36:57  robin
 * The files kqml.h and logmsg.h moved up one level.
 *
 * Revision 1.1  1993/08/06  18:31:01  robin
 * Initial revision
 *
 *
 */

/*
 *	(c) Copyright 1993 Paramax Systems Corp.
 *
 *	This material my be reproduced by or for the U.S.
 *	Government pursuant to the copyright license under
 *	the clause at DFARS 252.227-7013   (1991).
 */




#include <stdarg.h>
#include <stdio.h>
#include <string.h>
#include <floatingpoint.h>
#include <errno.h>
#include <ctype.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/file.h>
#include </usr/local/q3.1.3/generic/qplib3.1.3/embed/quintus.h>

#include <kqml.h>

/* Global Variables */
long         MAX_ATOM_LEN=4096;
QP_pred_ref  qp_call;


QP_term_ref
make_QP_error_msg (int err_num)
{
  QP_term_ref     pterm = QP_new_term_ref();
  QP_term_ref     pterm_head = QP_new_term_ref();
  QP_term_ref     head = QP_new_term_ref();
  QP_term_ref     tail = QP_new_term_ref();
  QP_term_ref     nil = QP_new_term_ref();
  
  
  QP_put_atom(nil, QP_atom_from_string("[]"));  
  QP_put_atom(head, QP_atom_from_string("ERROR"));
  QP_put_integer(tail, err_num);
  QP_cons_list(pterm_head, head, tail);
  QP_cons_list(pterm, pterm_head, nil);
  return (pterm);
}



int
  is_integer(char *str)
{
  int i=0;

  while (str[i])
    {
      if (!isdigit(str[i]))
        {
          return(0);
        }
      i++;
    }
  return(1);
}


int
  is_float(char *str)
{
  int i=0;

  while (str[i])
    {
      if (!(isdigit(str[i]) ||
            str[i] == '.'   ||
            str[i] == '-'   ||
            str[i] == '+') )
        {
          return(0);
        }
      i++;
    }
  return(1);
}
      


QP_term_ref
  make_prolog_list (char *list, int *ctr)
{
  char         *str;
  char         c;
  int          quote_flag=0;
  int          first_flag;
  QP_term_ref  plist = QP_new_term_ref();
  QP_term_ref  sublist = QP_new_term_ref();
  QP_term_ref  nil = QP_new_term_ref();
  QP_term_ref  head = QP_new_term_ref();
  

  if (*ctr == 0)
    {
#ifdef DEBUG
      fprintf (stderr, "First time in make_prolog_list with '%s'\n", list);
      fflush (stderr);
#endif
    }
#ifdef DEBUG
  fprintf (stderr, "Here in make_prolog_list with ctr=%d\n", *ctr);
  fflush (stderr);
#endif

  QP_put_atom(nil, QP_atom_from_string("[]"));  

  str = (char *) calloc (MAX_ATOM_LEN);
  if (str == NULL)
    {
      fprintf (stderr, "Unable to malloc for str in make_prolog_list\n");
      fflush (stderr);
    }
  
  while (list[*ctr])
    {
      switch (list[*ctr])
	{
	case '"':
	  if (quote_flag)
	    {
	      quote_flag=0;
#ifdef DEBUG
	      fprintf (stderr, "      QP_put_atom (1) for '%s'\n", str);
	      fflush (stderr);
#endif
	      QP_put_atom(head, QP_atom_from_string(str));
	      if (QP_is_list(plist))
		{
		  QP_cons_list(plist, head, plist);
		}
	      else
		{
		  QP_cons_list(plist, head, nil);
		}
	      bzero(str, MAX_ATOM_LEN);
	    }
	  else
	    {
	      quote_flag=1;
	    }
	  break;
	case '(':
	  if (quote_flag)
	    {
	      strncat(str,&list[*ctr],1);
	    }
	  else
	    {
	      first_flag = *ctr;
	      ++*ctr;
	      sublist = make_prolog_list (list, ctr);
	      if (!first_flag) return (sublist);
	      if (QP_is_list(plist))
		{
		  QP_cons_list(plist, sublist, plist);
		}
	      else
		{
		  QP_cons_list(plist, sublist, nil);
		}
	      bzero(str, MAX_ATOM_LEN);
	    }
	  break;
	case ')':     /* end of list, so all done */
	  if (quote_flag)
	    {
	      strncat(str,&list[*ctr],1);
	    }
	  else
	    {
	      if (strlen(str) > 0)
		{
		  if (is_integer(str))
		    {
#ifdef DEBUG
		      fprintf (stderr, "      QP_put_integer (2) for '%s'\n", str);
		      fflush (stderr);
#endif
		      QP_put_integer(head, atoi(str));
		    }
		  else if (is_float(str))
		    {
#ifdef DEBUG
		      fprintf (stderr, "      QP_put_float (2) for '%s'\n", str);
		      fflush (stderr);
#endif
		      QP_put_float(head, atof(str));
		    }
		  else
		    {
#ifdef DEBUG
		      fprintf (stderr, "      QP_put_atom (2) for '%s'\n", str);
		      fflush (stderr);
#endif
		      QP_put_atom(head, QP_atom_from_string(str));
		    }
		  QP_cons_list(plist, head, plist);
		  bzero(str, MAX_ATOM_LEN);
		}
	      free (str);
	      
	      return (plist);
	    }
	  break;
	case ' ':     /* blank spaces indicate a new word */
	  if (!quote_flag)
	    {
	      if (strlen(str) > 0)
		{
		  if (is_integer(str))
		    {
#ifdef DEBUG
		      fprintf (stderr, "      QP_put_integer (3) for '%s'\n", str);
		      fflush (stderr);
#endif
		      QP_put_integer(head, atoi(str));
		    }
		  else if (is_float(str))
		    {
#ifdef DEBUG
		      fprintf (stderr, "      QP_put_float (3) for '%s'\n", str);
		      fflush (stderr);
#endif
		      QP_put_float(head, atof(str));
		    }
		  else
		    {
#ifdef DEBUG
		      fprintf (stderr, "      QP_put_atom (3) for '%s'\n", str);
		      fflush (stderr);
#endif
		      QP_put_atom(head, QP_atom_from_string(str));
		    }
		  if (QP_is_list(plist))
		    {
		      QP_cons_list(plist, head, plist);
		    }
		  else
		    {
		      QP_cons_list(plist, head, nil);
		    }
		  bzero(str, MAX_ATOM_LEN);
		}
	    }
	  else
	    {
	      strncat(str,&list[*ctr],1);
	    }
	  break;
	default:
	  strncat(str,&list[*ctr],1);
	  break;
	}

      ++*ctr;
    }

  free (str);

  return (plist);
}


QP_term_ref
rev_prolog_list (QP_term_ref plist)
{
  QP_term_ref head     = QP_new_term_ref();
  QP_term_ref tail     = QP_new_term_ref();
  QP_term_ref rev_head = QP_new_term_ref();
  QP_term_ref rev_tail = QP_new_term_ref();
  QP_term_ref rev_list = QP_new_term_ref();

  QP_put_atom(rev_list, QP_atom_from_string("[]"));  

  while (QP_is_list(plist))
    {
      QP_get_list (plist, head, plist);
      if (QP_is_list(head))
	{
	  rev_head = rev_prolog_list (head);
	}
      else
	{
	  rev_head = head;
	}
      QP_cons_list(rev_list, rev_head, rev_list);
    }

  return (rev_list);
}



QP_term_ref
  make_kqml_term (kexpression *ppv, u_int ppv_len)
{
  QP_term_ref  plist   = QP_new_term_ref();
  QP_term_ref  sublist = QP_new_term_ref();
  QP_term_ref  key     = QP_new_term_ref();
  QP_term_ref  val     = QP_new_term_ref();
  QP_term_ref  rev_val = QP_new_term_ref();
  QP_term_ref  nil     = QP_new_term_ref();
  char         *str;
  int          i=0;
  int          n=0;
  int          j=1;
  int          zero=0;

#ifdef DEBUG
  fprintf (stderr, "Here in make_kqml_term with ppv_len of %d\n", ppv_len);
  fflush (stderr);
#endif


  QP_put_atom(nil, QP_atom_from_string("[]"));  

  while (i < ppv_len)
    {
#ifdef DEBUG
      fprintf (stderr, "  TOP OF WHILE LOOP\n");
      fflush (stderr);
      fprintf (stderr, "  working on key '%s'\n", ppv[i].key);
      fflush (stderr);
#endif
      
      QP_put_atom(key, QP_atom_from_string(ppv[i].key));
      if ( strcmp(":content",ppv[i].key) == 0 )
	{
	  if (ppv[i].value[0] == '\"')   /* " this is here only to prevent underline all the way down */
	    {
	      ppv[i].value++;
	      ppv[i].value[strlen(ppv[i].value)-1] = '\0';
	    }
#ifdef DEBUG
	  fprintf (stderr, "working on content %s\n", ppv[i].value);
	  fflush (stderr);
#endif
	  rev_val = make_prolog_list (ppv[i].value, &zero);
	  /* this is a hack because the parser should be rewritten (when there's time) to be
	     more generic than it is now, and do this part right. */
	  val = rev_prolog_list (rev_val);
	}
      else
	{
#ifdef DEBUG
	  fprintf (stderr, "  creating an atom for '%s'\n", ppv[i].value);
	  fflush (stderr);
#endif
	  QP_put_atom(val, QP_atom_from_string(ppv[i].value));
	}

#ifdef DEBUG
      fprintf (stderr, "  about to QP_cons_list for key and val\n");
      fflush (stderr);
#endif
      QP_cons_list(sublist, key, val);
#ifdef DEBUG
      fprintf (stderr, "  about to check with QP_is_list\n");
      fflush (stderr);
#endif
      if (QP_is_list(plist))
	{
	  QP_cons_list(plist, sublist, plist);
	}
      else
	{
	  QP_cons_list(sublist, sublist, nil);
	  QP_put_term(plist, sublist);
	}
      
      i++;
    }
#ifdef DEBUG
  fprintf (stderr, "  returning from make_kqml_term\n");
  fflush (stderr);
#endif
  return (plist);
}



QP_term_ref
  make_prolog_term (kqml_message *kmsg)
{
  QP_term_ref  pterm = QP_new_term_ref();
  QP_term_ref  pterm_head = QP_new_term_ref();
  QP_term_ref  pterm_tail;
  QP_term_ref  perf = QP_new_term_ref();
  QP_term_ref  perf_name = QP_new_term_ref();
  QP_term_ref  nil = QP_new_term_ref();

  char         *content;
  char         *term;
  int          i=0;
  int          j=1;

#ifdef DEBUG
  fprintf (stderr, "Here in make_prolog_term\n");
  fflush (stderr);
#endif


  QP_put_atom(nil, QP_atom_from_string("[]"));  

#ifdef DEBUG
  fprintf (stderr, "  Begin construction of prolog term\n");
  fflush (stderr);
#endif
  QP_put_atom(perf, QP_atom_from_string("performative"));
  QP_put_atom(perf_name, QP_atom_from_string(kmsg->performative));

  QP_cons_list(pterm_head, perf, perf_name);

  pterm_tail = make_kqml_term (kmsg->ppv.ppv_val, kmsg->ppv.ppv_len);

  QP_cons_list(pterm, pterm_head, pterm_tail);

#ifdef DEBUG
  fprintf (stderr, "  returning from make_prolog_term\n");
  fflush (stderr);
#endif
  return (pterm);
}



/*
 * qp_kqml_send_msg
 *
 * Send a message to a another agent for execution and return of results.
 *
 * Parameters:
 *
 *	1) performative
 *         The performative to be used for this KQML expression.
 *
 *	2) content
 *	   The query to be executed by the remote database.  This should
 *	   be a pointer to a character array.  The ending ';' must not be
 *	   included in the query string.
 *
 *	3) rec_agent
 *	   This is the symbolic name of the agent to which the message
 *	   is to be sent.  This argument must be a pointer to a character
 *         string.
 *
 *      4) reply
 *         This is a flag that will be 0 if no reply is requested or some
 *         non-zero number if a reply is requested.
 *
 * Value Returned:
 *
 *	Pointer to a character string - OK, the query has been successfully
 *		executed.
 *	NULL - Failure.  Either the query was unable to be executed on the
 *		remote database or there was a problem during transmission
 *		of the query to or from the database wrapper.
 *
 */

QP_term_ref
  qp_kqml_send_msg (char *perf, QP_term_ref content_list, char *rec_agent, int reply, ...)
{
  QP_term_ref     pterm = QP_new_term_ref();
  QP_term_ref     pterm_head = QP_new_term_ref();
  QP_term_ref     head = QP_new_term_ref();
  QP_term_ref     tail = QP_new_term_ref();
  QP_term_ref     nil = QP_new_term_ref();
  kqml_message 	  *omsg;
  kqml_message 	  *r_kmsg = NULL;
  char            *content;
  long            size=1024;
  char 		  *field;
  char 		  *value;
  int 		  res, ret, i;
  long int        c;
  va_list	  fp;

#ifdef DEBUG
  fprintf (stderr, "Here in qp_kqml_send_msg with a content list and;\n  %s\n  %s\n  %d\n",
	   perf, rec_agent, reply);
  fflush (stderr);
#endif

  /* The content will come in as a prolog list of ASCII characters (to get around the
     limitation on the size of prolog atoms), so build the content here. */
  content = (char *) malloc (size);
  if (content == NULL)
    {
#ifdef DEBUG
      fprintf (stderr, "qp_kqml_send_msg: Unable to malloc content for initial allocation\n");
      fflush (stderr);
#endif
      return (make_QP_error_msg(-3));
    }
  i = 0;
  QP_get_list (content_list, head, tail);
  QP_get_integer(head, &c);
  content[i++] = c;
  while (QP_is_list(tail))
    {
      QP_get_list(tail, head, tail);
      QP_get_integer(head, &c);
      content[i++] = c;
      if (i >= size)
	{
	  size += 1024;
	  content = (char *) realloc (content, size);
	  if (content == NULL)
	    {
#ifdef DEBUG
	      fprintf (stderr, "qp_kqml_send_msg: Unable to realloc for %d bytes\n", size);
	      fflush (stderr);
#endif
	      return (make_QP_error_msg(-4));
	    }
	}
    }
  content[i] = '\0';

  ret = kqml_send_msg (perf, content, rec_agent, "t", &r_kmsg, NULL);
  if (ret < 0)
    {
#ifdef DEBUG
      fprintf (stderr, "kqml_send_msg has failed\n");
      fflush (stderr);
#endif
      return (make_QP_error_msg(ret));
    }
#ifdef DEBUG
  fprintf (stderr, "qp_kqml: returned from qp_kqml_send_msg with;\n");
  fflush (stderr);
  kqml_print_msg (stderr, r_kmsg);
  fflush (stderr);
#endif

  if (r_kmsg == NULL)
    {
#ifdef DEBUG
      fprintf (stderr, "  reply is NULL\n");
      fflush (stderr);
#endif
      return (make_QP_error_msg(0));
    }
  else
    {
#ifdef DEBUG
      fprintf (stderr, "  print the reply from qp_kqml_send_msg;\n");
      fflush (stderr);
#endif
    }

#ifdef DEBUG
  fprintf (stderr, "  make the prolog term\n");
  fflush (stderr);
#endif
  pterm = make_prolog_term (r_kmsg);

#ifdef DEBUG
  fprintf (stderr, "  return\n");
  fflush (stderr);
#endif
  return (pterm);
}



static void
handle_QP_signal (int sig, int code)
{
  int  ret;

  ret = QP_action(QP_MENU);
  if (ret == QP_FAILURE)
    {
      fprintf (stderr, "\nFAILURE in handle_QP_signal/1\n\n");
      fflush (stderr);
    }
  else if ( ret == QP_ERROR)
    {
      fprintf (stderr, "\nFAILURE in handle_QP_signal/1\n\n");
      fflush (stderr);
    }
}  



QP_term_ref
qp_kqml_initialize (char *agent_name)
{
  int  ret;
  
  /* First, do the standard KQML initialization */
  if (ret = kqml_initialize (agent_name) < 0)
    {
      return (make_QP_error_msg (ret));
    }

  /* Create the pointer to the Prolog predicate runtime_entry */
  qp_call = QP_predicate ("call", 1, "user");
  if ( (int) qp_call == QP_FAILURE)
    {
      fprintf (stderr, "\nFAILURE on attempt to find Quintus predicate call/1\n\n");
      fflush (stderr);
    }
  else if ( (int) qp_call == QP_ERROR)
    {
      fprintf (stderr, "\nERROR on attempt to find Quintus predicate call/1\n\n");
      fflush (stderr);
    }
  
  /* Establish a signal handler for Control-C */
  signal (SIGINT, handle_QP_signal);
}
